package algorithm0601;

import java.util.concurrent.*;
import static util450.Util450.*;

/**
 * Author: Stan Warford
 * File: Algorithm0601.java
 **/

public class Algorithm0601 extends Thread {

   static volatile int n = 0;
   static Semaphore s = new Semaphore(1);
   private int processID;

   Algorithm0601(int pID) {
      processID = pID;
   }

   public void run() {
      int temp;
      if (processID == 1) { // Process p
         for (int i = 0; i < 10; i++) {
            try {
               randomDelay(20);
               System.out.println("p.i == " + i);
               // Preprotocol
               s.acquire();
               // Critical section
               randomDelay(20);
               temp = n;
               randomDelay(20);
               n = temp + 1;
               // Postprotocol
               s.release();
            } catch (InterruptedException e) {
            }
         }
      } else if (processID == 2) { // Process q
         for (int i = 0; i < 10; i++) {
            try {
               randomDelay(20);
               System.out.println("q.i == " + i);
               // Preprotocol
               s.acquire();
               // Critical section
               randomDelay(20);
               temp = n;
               randomDelay(20);
               n = temp + 1;
               // Postprotocol
               s.release();
            } catch (InterruptedException e) {
            }
         }
      }
   }

   public static void main(String[] args) {
      Algorithm0601 p = new Algorithm0601(1);
      Algorithm0601 q = new Algorithm0601(2);
      p.start();
      q.start();
      try {
         p.join();
         q.join();
      } catch (InterruptedException e) {
      }
      System.out.println("The value of n is " + n);
   }
}
