package algorithm0701;

import java.util.concurrent.*;
import static util450.Util450.*;

/**
 * Author: Stan Warford
 * File: Algorithm0701.java
 **/

public class Algorithm0701 extends Thread {

   private int processID;
   private CriticalSection cs;

   Algorithm0701(int pID, CriticalSection criticalSection) {
      processID = pID;
      cs = criticalSection;
   }

   public void run() {
      if (processID == 1) { // Process p
         for (int i = 0; i < 10; i++) {
            try {
               randomDelay(10);
               System.out.println("p.i == " + i);
               cs.increment();
            } catch (InterruptedException e) {
            }
         }
      } else if (processID == 2) { // Process q
         for (int i = 0; i < 10; i++) {
            try {
               randomDelay(10);
               System.out.println("q.i == " + i);
               cs.increment();
            } catch (InterruptedException e) {
            }
         }
      }
   }

   public static void main(String[] args) {
      CriticalSection cs = new CriticalSection();
      Algorithm0701 p = new Algorithm0701(1, cs);
      Algorithm0701 q = new Algorithm0701(2, cs);
      p.start();
      q.start();
      try {
         p.join();
         q.join();
      } catch (InterruptedException e) {
      }
      System.out.println("The value of n is " + cs.get());
   }
}
