package algorithm0703;

final class PCMonitor {
   final int n = 5;
   int out = 0, in = 0;
   volatile int count = 0;
   final int[] buffer = new int[n];

   synchronized void append(int v) {
      while (count == n) {
         try {
            wait();
         } catch (InterruptedException e) {
         }
      }
      buffer[in] = v;
      in = (in + 1) % n;
      count = count + 1;
      System.out.println("Producer put " + v);
      notifyAll();
   }

   synchronized int take() {
      int temp;
      while (count == 0) {
         try {
            wait();
         } catch (InterruptedException e) {
         }
      }
      temp = buffer[out];
      out = (out + 1) % n;
      count = count - 1;
      System.out.println("Consumer got " + temp);
      notifyAll();
      return temp;
   }
}
