package exceptionreview;

/**
 * Example for CoSc 450, Programming Paradigms to illustrate exceptions
 * propagating up the call chain.
 *
 * <p>File:
 * <code>ExceptionReview.java</code>
 *
 * @author Stan Warford
 */
public class ExceptionReview {

   public static void main(String[] args) {
      int x = Integer.parseInt(args[0]);
      System.out.println("Main started with x == " + x);
      int x2;
      try {
         x2 = top(x);
      } catch (MyException e) {
         System.out.println("Caught an exception: " + e);
         x2 = 99;
      }
      System.out.println("Main ending with x2 == " + x2);
   }

   static int top(int y) {
      System.out.println("Top started with y == " + y);
      int y2 = bottom(y);
      System.out.println("Top returning y2 == " + y2);
      return y2;
   }

   static int bottom(int z) throws MyException {
      System.out.println("Bottom started with z == " + z);
      if (z < 0) {
         throw new MyException("Throwing MyException");
      }
      System.out.println("Bottom returning 20");
      return 20;
   }
}
